#pragma once

#include <sstream>
#include "m3hStd.h"

namespace melissa
{

class MELISSA_API m3cLoggerStream
{
public:
    m3cLoggerStream(const m3cLoggerStream &other);
    m3cLoggerStream(const std::string &prefix, bool fatal);
    ~m3cLoggerStream();

    m3cLoggerStream &operator <<(const std::string &v);
    m3cLoggerStream &operator <<(const int v);
    m3cLoggerStream &operator <<(const double v);

private:
    mutable bool m_fatal = false;
    const std::string m_prefix;
    std::stringstream out;
};

class MELISSA_API m3cLogger
{
public:
    static m3cLoggerStream fatal();
    static m3cLoggerStream warning();
    static m3cLoggerStream info();

private:
};

}
