#ifndef M3H_STD_H
#define M3H_STD_H

#include <map>
#include <set>
#include <stack>
#include <vector>
#include <string>
#include <memory>
#include <stdint.h>


#ifdef _WIN32
    #ifdef MELISSA_EXPORT
        #define MELISSA_API __declspec(dllexport)
    #else
        #define MELISSA_API __declspec(dllimport)
    #endif
#else
    #define MELISSA_API __attribute__ ((visibility ("default")))
#endif

namespace melissa
{

template <typename T>
bool remove_from_vector(std::vector<T> &v, const T &t)
{
    for (uint64_t i = 0; i < v.size(); ++i)
    {
        if (v[i] == t)
        {
            v.erase(v.begin() + i);
            return true;
        }
    }
    return false;
}

template <typename T>
void delete_all(const std::vector<T> &v)
{
    for (auto i : v)
    {
        delete i;
    }
}

}

#endif //M3H_STD_H
