LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

LOCAL_MODULE    := melissa

SRC_DIR := ..
INC_DIR := $(LOCAL_PATH)/..

LOCAL_SRC_FILES := \
	$(SRC_DIR)/lodepng/lodepng.cpp \
	$(SRC_DIR)/jpgd/jpgd.cpp \
	$(SRC_DIR)/common/m3cLogger.cpp \
	$(SRC_DIR)/render/m3cAbstractMesh.cpp \
	$(SRC_DIR)/render/m3cFrustum.cpp \
	$(SRC_DIR)/render/m3cHardwareMesh.cpp \
	$(SRC_DIR)/render/m3cLinkedMesh.cpp \
	$(SRC_DIR)/render/m3cProgram.cpp \
	$(SRC_DIR)/render/m3cRender.cpp \
	$(SRC_DIR)/render/m3cTexture.cpp \
	$(SRC_DIR)/render/m3cTextureRenderTarget.cpp \
	$(SRC_DIR)/physics/m3cPhysicsBody.cpp \
	$(SRC_DIR)/physics/m3cPhysicsWorld.cpp \
	$(SRC_DIR)/platform/android/m3cAndroidFile.cpp \
	$(SRC_DIR)/platform/android/m3cAndroidFileSystem.cpp \
	$(SRC_DIR)/platform/android/m3cAndroidSystem.cpp \
	$(SRC_DIR)/root/m3cCamera.cpp \
	$(SRC_DIR)/root/m3cLight.cpp \
	$(SRC_DIR)/root/m3cModelSetsLoader.cpp \
	$(SRC_DIR)/root/m3cModel.cpp \
	$(SRC_DIR)/root/m3cParticles.cpp \
	$(SRC_DIR)/root/m3cBatch.cpp \
	$(SRC_DIR)/root/m3cMovable.cpp \
	$(SRC_DIR)/root/m3cRoot.cpp \
	$(SRC_DIR)/root/m3cScene.cpp \
	$(SRC_DIR)/root/m3cTextureLoader.cpp \
	$(SRC_DIR)/root/m3cVisual.cpp \
	$(SRC_DIR)/root/m3cSkeleton.cpp \
	${SRC_DIR}/third/jsoncpp/src/json_reader.cpp \
	${SRC_DIR}/third/jsoncpp/src/json_value.cpp \
	${SRC_DIR}/third/jsoncpp/src/json_writer.cpp \

#LOCAL_LDLIBS    := -llog -lGLESv2 -landroid -lz  -lfreeimage -lgnustl_static

LOCAL_C_INCLUDES += \
	$(INC_DIR)/common \
	$(INC_DIR)/platform \
	$(INC_DIR)/platform/android \
	$(INC_DIR)/render \
	$(INC_DIR)/root \
	$(INC_DIR)/physics \
	$(INC_DIR)/third/jsoncpp/include \

LOCAL_CFLAGS += -DMELISSA_ANDROID -DMELISSA_UNIX -DMELISSA_MOBILE
LOCAL_CFLAGS += -std=gnu++11
LOCAL_CPPFLAGS += -O2

include $(BUILD_STATIC_LIBRARY)