#pragma once

#include <btBulletDynamicsCommon.h>

#include "m3hGlm.h"
#include "m3iPhysicsBody.h"

namespace melissa
{

class m3iPhysicsWorldManager;

class m3cPhysicsBody : public m3iPhysicsBody
{
public:
    m3cPhysicsBody(m3iPhysicsWorldManager *worldMan, btCollisionShape *shape, float mass);
    ~m3cPhysicsBody();

    void setModelMatrix(const glm::mat4 &matrix);
    glm::mat4 getModelMatrix() const;
    btRigidBody *getRigidBody() const;

private:
    m3iPhysicsWorldManager *m_worldMan;
    btRigidBody *m_body;
    btCollisionShape *m_shape;
    btDefaultMotionState *m_state;
};

}
