#include "m3cLogger.h"
#include "m3cAndroidFile.h"

namespace melissa
{

m3cAndroidFile::m3cAndroidFile(const std::string &filename)
{
    m_file = AAssetManager_open(g_assetManager, filename.c_str(), AASSET_MODE_UNKNOWN);
    if (!m_file)
    {
        m3cLogger::fatal() << "file" << filename << "not found";
        return;
    }
    m_size = AAsset_getLength(m_file);
}

m3cAndroidFile::~m3cAndroidFile()
{
    close();
}

void m3cAndroidFile::close()
{
    if(m_file)
        AAsset_close(m_file);

    m_file = 0;
}

bool m3cAndroidFile::isEof() const
{
    if (!m_file)
        return true;
    return AAsset_getRemainingLength(m_file) == 0;
}

uint64_t m3cAndroidFile::getSize() const
{
    return m_size;
}

uint64_t m3cAndroidFile::read(void *data, uint64_t size)
{
    return AAsset_read(m_file, data, size);
}

}
