#pragma once

#include <jni.h>
#include <android/asset_manager_jni.h>

#include "m3iSystem.h"

namespace melissa
{

extern AAssetManager *g_assetManager;

class m3cAndroidSystem : public m3iSystem
{
public:
    m3cAndroidSystem();
    ~m3cAndroidSystem();

    m3iFileSystem *getFileSystem() const;
    double getTime() const;

    void playMusic(const std::string &filename);
    void stopMusic();
    void pauseMusic();
    void resumeMusic();
    m3iSound *getSound(const std::string &filename);
    void saveParameter(const std::string &name, const std::string &value);
    std::string loadParameter(const std::string &name);

private:
    m3iFileSystem *m_fileSystem = 0;
};

}
