#pragma once

#include "m3iSystem.h"

namespace melissa
{

class m3cDesktopSystem : public m3iSystem
{
public:
    m3cDesktopSystem();
    ~m3cDesktopSystem();

    m3iFileSystem *getFileSystem() const;
    double getTime() const;

    void playMusic(const std::string &filename);
    void stopMusic();
    void pauseMusic();
    void resumeMusic();
    m3iSound *getSound(const std::string &filename);
    void saveParameter(const std::string &name, const std::string &value);
    std::string loadParameter(const std::string &name);

private:
    m3iFileSystem *m_fileSystem = 0;
};

}
