#include "m3cLogger.h"
#include "m3cDiskFile.h"

namespace melissa
{

m3cDiskFile::m3cDiskFile(const std::string &filename)
{
    m_file = fopen(filename.c_str(), "rb");
    if (m_file)
    {
        fseek(m_file, 0, SEEK_END);
        m_size = ftell(m_file);
        fseek(m_file, 0, SEEK_SET);
    }
    else
    {
        m3cLogger::fatal() << "file" << filename << "not exists";
    }
}

m3cDiskFile::~m3cDiskFile()
{
    close();
}

void m3cDiskFile::close()
{
    if (m_file)
        fclose(m_file);
    m_file = 0;
}

bool m3cDiskFile::isEof() const
{
    if (!m_file)
        return true;
    return feof(m_file);
}

uint64_t m3cDiskFile::getSize() const
{
    return m_size;
}

uint64_t m3cDiskFile::read(void *data, uint64_t size)
{
    if (!m_file)
        return 0;
    return fread(data, 1, size, m_file);
}

}
