#pragma once

#include "m3hStd.h"
#include "m3eInputAction.h"
#include "m3eScreenOrientation.h"

namespace melissa
{

class m3iSystem;
class m3iRootApplication;

class m3iApplication
{
public:
    virtual ~m3iApplication() {}
    virtual m3eScreenOrientation getSimulatorOrientation() const { return m3eScreenOrientationLandscape; }
    virtual void initialize(m3iSystem *system) = 0;
    virtual void render() = 0;
    virtual void reload() {}
    virtual void touch(m3eInputAction act, uint8_t id, uint16_t x, uint16_t y) {}
    virtual void keyboard(m3eInputAction act, uint8_t key) {}
    virtual void stop() {}
    virtual void close() {}
};

}

melissa::m3iApplication* MELISSA_API createApplication(melissa::m3iRootApplication *rootApp);
