#pragma once

#include "m3hStd.h"

namespace melissa
{

class m3iSound;
class m3iFileSystem;

class m3iSystem
{
public:
    virtual ~m3iSystem() {}

    virtual void playMusic(const std::string &filename) = 0;
    virtual void stopMusic() = 0;
    virtual void pauseMusic() = 0;
    virtual void resumeMusic() = 0;
    virtual m3iSound *getSound(const std::string &filename) = 0;

    //! get file system
    virtual m3iFileSystem *getFileSystem() const = 0;

    //! getting time in milliseconds (ex 2.340 = 2 sec, 340 msec)
    virtual double getTime() const = 0;

    virtual void saveParameter(const std::string &name, const std::string &value) = 0;
    virtual std::string loadParameter(const std::string &name) = 0;
};

}
