#pragma once

#include "m3iMesh.h"
#include "m3sMeshData.h"
#include "m3iResource.h"

namespace melissa
{

class m3iResourceManager;

class m3cAbstractMesh : public m3iMesh, public m3iResource
{
public:
    m3cAbstractMesh(m3iResourceManager *resMan, const m3sMeshData &data);
    ~m3cAbstractMesh();

    std::vector<m3sMeshSurface> &editSurfaces();

    virtual void bind() = 0;
    virtual const void *getVertexPointer() const = 0;
    virtual const void *getElementPointer() const = 0;
    const m3sMeshData &getData() const;
    float getBoundingCubeSize() const;
    const m3sSurfaceMaterial &getSurfaceMaterial(uint64_t index) const;
    void setSurfaceMaterial(uint64_t index, const m3sSurfaceMaterial &material);

protected:
    void calculateAABB();

protected:
    m3sMeshData m_data;
    float m_boundingCubeSize = 0;
    m3iResourceManager *m_resMan = 0;
    glm::vec3 m_aabb[2] = { {9999, 9999, 9999}, {-9999, -9999, -9999} };
};

}
