#pragma once

#include "m3hOpenGl.h"
#include "m3cAbstractMesh.h"

namespace melissa
{

class m3cHardwareMesh : public m3cAbstractMesh
{
public:
    m3cHardwareMesh(m3iResourceManager *resMan, const m3sMeshData &data, bool optimize);
    ~m3cHardwareMesh();

    void bind();
    const void *getVertexPointer() const;
    const void *getElementPointer() const;

    void freeHandles();
    void reloadHandles();

private:
    void optimize();

private:
    GLuint m_vbo[2] = {0, 0};
    const std::vector<m3sVertex> m_vertices;
    std::vector<m3sElement> m_elements;
};

}
