#pragma once

#include "m3hStd.h"
#include "m3hOpenGl.h"
#include "m3iTexture.h"
#include "m3iResource.h"

namespace melissa
{

class m3iResourceManager;

class m3cTexture : public m3iTexture, public m3iResource
{
    enum Format
    {
        Byte,
        Float
    };

public:
    m3cTexture(m3iResourceManager *resMan, uint16_t width, uint16_t height, const void *data, uint64_t size, Format format = Byte);
    ~m3cTexture();

    //! binds texture
    void bind(uint8_t layer);

    GLuint getHandle() const;

    uint16_t getWidth() const;
    uint16_t getHeight() const;

    void freeHandles();
    void reloadHandles();

    void updateData(const void *data, uint64_t size);

private:
    GLuint m_texture = 0;
    std::vector<uint8_t> m_data;
    uint16_t m_width = 0, m_height = 0;
    m3iResourceManager *m_resMan = 0;
    Format m_format;
};

}
