#pragma once

#include "m3hOpenGl.h"
#include "m3iResource.h"

namespace melissa
{

class m3cTexture;
class m3iResourceManager;

class m3cTextureRenderTarget : public m3iResource
{
public:
    m3cTextureRenderTarget(m3iResourceManager *resMan, m3cTexture *texture);
    ~m3cTextureRenderTarget();

    m3cTexture *getTexture() const;
    void bind();
    static void unbind();

    void freeHandles();
    void reloadHandles();

private:
    bool m_reloadMode = false;
    GLuint m_fb = 0, m_rb = 0;
    m3cTexture *m_texture = 0;
    m3iResourceManager *m_resMan;
};

}
