#pragma once

#include "m3hStd.h"
#include "m3sVertex.h"
#include "m3sElement.h"
#include "m3sMeshSurface.h"

namespace melissa
{

class m3iSkeleton;

struct m3sMeshData
{
    uint64_t framesCount = 1;
    const m3sVertex *vertices = 0;
    uint64_t verticesCount = 0;
    const m3sElement *elements;
    uint64_t elementsCount = 0;
    std::vector<m3sMeshSurface> surfaces;
    bool useElements = true;
    bool hasMorphAnim = false;
    bool hasSkeletalAnim = false;

    //! will delete with mesh
    m3iSkeleton *skeleton = 0;
};

}
