#pragma once

#include "m3sSun.h"
#include "m3sFog.h"
#include "m3sLightData.h"
#include "m3sShadowsData.h"

namespace melissa
{

struct m3sRenderFrameData
{
    bool lighting = true;
    m3sFog fog;
    m3sShadowsData shadowsData;
    m3sLightData lights[4];
    uint8_t usedLightsCount = 0;
    m3sSun sun;
    glm::vec3 cameraPosition = glm::vec3(0.0);
    glm::mat4 viewMatrix = glm::mat4(1.0);
    glm::mat4 projectionMatrix = glm::mat4(1.0);
    glm::vec4 clearColor = {0.1, 0.2, 0.3, 1.0};
};

}
