#pragma once

#include "m3iBatch.h"
#include "m3cVisual.h"
#include "m3sVertex.h"
#include "m3cMovable.h"
#include "m3sDrawMeshData.h"
#include "m3iBatchContext.h"
#include "m3sBatchDrawData.h"

namespace melissa
{

class m3iMesh;
class m3iRender;
class m3iTexture;
struct m3sRenderFrameData;
class m3iBatchDrawDelegate;

class m3cBatch : public m3cMovable, public m3iBatch, public m3iBatchContext, public m3cVisual
{
public:
    m3cBatch(m3iMovableManager *movMan, m3iRender *render, const glm::vec2 &spaceSize, m3iTexture *texture, m3iBatchDrawDelegate *drawDel, uint64_t max, bool is2d);
    void draw(m3iRender *render, m3sRenderFrameData &frameData);
    void draw(const m3sBatchDrawData &data);

private:
    glm::vec4 convertFrame(const glm::vec4 &frame);
    void addBatchDrawData(uint64_t index, const m3sBatchDrawData &data);

private:
    m3iMesh *m_mesh;
    uint64_t m_max = 0;
    m3iTexture *m_texture;
    m3iBatchDrawDelegate *m_drawDel;
    std::vector<m3sVertex> m_vertices;
    std::vector<m3sBatchDrawData> m_batchDraws;
    m3sDrawMeshData m_drawMeshData;
    glm::vec2 m_spaceSize;
};

}
