#include "m3cLight.h"
#include "m3iMovableManager.h"
#include "m3sRenderFrameData.h"

namespace melissa
{

m3cLight::m3cLight(m3iMovableManager *movMan)
    : m3cMovable(movMan)
{

}

void m3cLight::use(uint64_t index, m3iRender *render, m3sRenderFrameData &frameData)
{
    frameData.lights[index].diffuseColor = m_diffuseColor;
    frameData.lights[index].attenuation = m_attenuationFactor;
    frameData.lights[index].position = getPosition(true);
    frameData.lights[index].direction = getDirection(true);
}

void m3cLight::setDiffuseColor(const glm::vec4 &color)
{
    m_diffuseColor = color;
}

void m3cLight::setAttenuation(const glm::vec3 &factor)
{
    m_attenuationFactor = factor;
}

}
