#pragma once

#include "m3iLight.h"
#include "m3cMovable.h"

namespace melissa
{

class m3iRender;
struct m3sRenderFrameData;

class m3cLight : public m3cMovable, public m3iLight
{
public:
    m3cLight(m3iMovableManager *movMan);
    void use(uint64_t index, m3iRender *render, m3sRenderFrameData &frameData);
    void setDiffuseColor(const glm::vec4 &color);
    void setAttenuation(const glm::vec3 &factor);

private:
    glm::vec4 m_diffuseColor = {1, 1, 1, 1};
    glm::vec3 m_attenuationFactor = {0.01, 0.01, 0.01};
};

}
