#pragma once

#include "m3iModel.h"
#include "m3cVisual.h"
#include "m3cMovable.h"
#include "m3sAnimation.h"
#include "m3sDrawMeshData.h"

namespace melissa
{

class m3iMesh;
class m3iRender;
class m3sRenderFrameData;

class m3cModel : public m3cMovable, public m3iModel, public m3cVisual
{
public:
    m3cModel(m3iMovableManager *movMan, m3iMesh *mesh);
    void draw(m3iRender *render, m3sRenderFrameData &frameData);
    void update(double dt);
    float getBoundingCubeSize() const;

    void setCastShadowsEnabled(bool enabled);
    void setReceiveShadowsEnabled(bool enabled);

    m3iMesh *getMesh() const;

    uint64_t getMeshSurfacesCount() const;
    const m3sSurfaceMaterial &getMeshSurfaceMaterial(uint64_t index) const;
    void setMeshSurfaceMaterial(uint64_t index, const m3sSurfaceMaterial &material);

    void setAnimation(const m3sAnimation &anim);
    void setBlendingEnabled(bool enabled);
    bool isBlendingEnabled() const;

private:
    double m_frameTime = 0;
    m3sAnimation m_anim;
    m3sDrawMeshData m_data;
    bool m_visible = true;
};

}
