#pragma once

#include "m3hStd.h"
#include "m3hGlm.h"
#include "json/json.h"
#include "m3sModelSet.h"

namespace melissa
{

class m3iMesh;
class m3cScene;
class m3iRender;
class m3iFileSystem;

class m3cModelSetsLoader
{
private:
    struct CachedObject
    {
        std::string name;
        m3iMesh *mesh = 0;
        glm::vec3 pos = {0,0,0};
        glm::quat ori = glm::quat();
        glm::vec3 scale = {1,1,1};
    };

    struct CachedScene
    {
        std::vector<CachedObject> objects;
    };

public:
    std::vector<m3sModelSet> loadModelSets(m3cScene *scene, m3iRender *render, m3iFileSystem *filesystem, const std::string &filename);

private:
    std::vector<m3sModelSet> createModelSets(const CachedScene &cachedScene, melissa::m3cScene *scene);
    void createObject(CachedScene &cachedScene, const Json::Value &object, m3cScene *scene, m3iRender *render);

private:
    std::map<std::string, CachedScene> m_cachedScenes;
};

}
