#pragma once

#include "m3cVisual.h"
#include "m3sVertex.h"
#include "m3cMovable.h"
#include "m3sElement.h"
#include "m3iParticles.h"
#include "m3sParticleUnit.h"
#include "m3eParticlesState.h"

namespace melissa
{

class m3iMesh;
class m3iRender;
class m3iTexture;
struct m3sRenderFrameData;
class m3iParticlesBehaviour;

class m3cParticles : public m3cMovable, public m3iParticles, public m3cVisual
{
public:
    m3cParticles(m3iMovableManager *movMan, m3iRender *render, m3iTexture *texture, m3iParticlesBehaviour *behav, uint64_t units);
    void setForEachMatrix(bool forEachMatrix);
    void draw(m3iRender *render, m3sRenderFrameData &frameData);
    void update(double dt);
    void setState(m3eParticlesState state);

private:
    void setParticleUnitToVertices(melissa::m3sRenderFrameData &frameData, uint64_t index, const m3sParticleUnit &unit);

private:
    m3iMesh *m_mesh;
    uint64_t m_units;
    m3iTexture *m_texture;
    bool m_forEachMatrix = false;
    m3iParticlesBehaviour *m_behav;
    std::vector<m3sVertex> m_vertices;
    std::vector<m3sElement> m_elements;
    std::vector<m3sParticleUnit> m_particleUnits;
};



}
