#pragma once

#include "m3iRoot.h"
#include "m3iSceneManager.h"
#include "m3iRootApplication.h"

namespace melissa
{

class m3cScene;
class m3iRender;

class m3cRoot : public m3iRoot, public m3iSceneManager
{
public:
    m3cRoot(m3iRender *render);
    ~m3cRoot();

    m3iScene *createScene(bool setAsCurrent);
    void setScene(m3iScene *scene);
    m3iScene *getScene() const;
    m3iFile *openFile(const std::string &filename);

    void registerScene(m3iScene *scene);
    void unregisterScene(m3iScene *scene);

    glm::vec4 getViewport() const;

    void initialize(m3iSystem *system);
    void render();
    void reload();

private:
    glm::vec4 m_lastViewport = glm::vec4();
    m3cScene *m_scene = 0;
    m3iSystem *m_system = 0;
    m3iRender *m_render = 0;
    bool m_dontUnregisterScenes = false;
    std::vector<m3iScene*> m_registeredScenes;
};

}

