#pragma once

#include "m3iVisual.h"
#include "m3iMovable.h"
#include "m3sSurfaceMaterial.h"

namespace melissa
{

class m3iTexture;
struct m3sAnimation;

class m3iModel : public virtual m3iMovable, public virtual m3iVisual
{
public:
    virtual void setCastShadowsEnabled(bool enabled) = 0;
    virtual void setReceiveShadowsEnabled(bool enabled) = 0;

    virtual uint64_t getMeshSurfacesCount() const = 0;
    virtual const m3sSurfaceMaterial &getMeshSurfaceMaterial(uint64_t index) const = 0;
    virtual void setMeshSurfaceMaterial(uint64_t index, const m3sSurfaceMaterial &material) = 0;

    virtual void setAnimation(const m3sAnimation &anim) = 0;
    virtual void setBlendingEnabled(bool enabled) = 0;
    virtual bool isBlendingEnabled() const = 0;
};

}
