#pragma once

#include "m3hGlm.h"

namespace melissa
{

class m3iAttachable;

class m3iMovable
{
public:
    virtual ~m3iMovable() {}
    virtual void setParent(const m3iMovable *parent) = 0;
    virtual void addPosition(const glm::vec3 &position) = 0;
    virtual void setPosition(const glm::vec3 &position) = 0;
    virtual void setQuaternion(const glm::quat &quaternion) = 0;
    virtual void setEuler(const glm::vec3 &rotation) = 0;
    virtual void setScale(const glm::vec3 &scale) = 0;
    virtual void pitch(float v, bool global) = 0;
    virtual void yaw(float v, bool global) = 0;
    virtual void roll(float v, bool global) = 0;
    virtual void rotate(const glm::quat &orientation, bool global) = 0;
    virtual void addScale(const glm::vec3 &scale) = 0;
    virtual glm::vec3 getPosition(bool global) const = 0;
    virtual glm::vec3 getDirection(bool global) const = 0;
    virtual glm::vec3 getEuler(bool global) const = 0;
    virtual glm::vec3 getScale(bool global) const = 0;
    virtual glm::mat4 getModelMatrix(bool global) const = 0;
    virtual void lookTo(const glm::vec3 &position) = 0;

    //! setup local model matrix
    virtual void setModelMatrix(const glm::mat4 &matrix) = 0;
};

}
