#pragma once

#include "m3hStd.h"
#include "m3sParticleUnit.h"
#include "m3eParticlesState.h"

namespace melissa
{

class m3iParticlesBehaviour
{
public:
    virtual ~m3iParticlesBehaviour() {}

    //! changed particles state
    virtual void changedState(m3eParticlesState state) = 0;

    //! initialize startup parameters
    virtual void initialize(std::vector<m3sParticleUnit> &units) = 0;

    //! change units
    virtual void update(std::vector<m3sParticleUnit> &units, double dt) = 0;
};

}
