#pragma once

#include "m3hGlm.h"
#include "m3hStd.h"

namespace melissa
{

class m3iFile;
class m3iScene;
class m3iSystem;

class m3iRoot
{
public:
    virtual ~m3iRoot() {}

    //! create new scene and set as current if needed
    virtual m3iScene *createScene(bool setAsCurrent) = 0;

    //! set scene as current
    virtual void setScene(m3iScene *scene) = 0;

    //! get current used scene
    virtual m3iScene *getScene() const = 0;

    //! open new file from system file system
    virtual m3iFile *openFile(const std::string &filename) = 0;

    virtual glm::vec4 getViewport() const = 0;
};

m3iRoot* MELISSA_API getRoot();

}
