#pragma once

#include "m3hStd.h"
#include "m3eInputAction.h"
#include "m3eScreenOrientation.h"

namespace melissa
{

class m3iRoot;
class m3iSystem;

class m3iRootApplication
{
public:
    virtual ~m3iRootApplication() {}
    virtual m3eScreenOrientation getSimulatorOrientation() const { return m3eScreenOrientationLandscape; }
    virtual std::string loadingScreenFilename() const { return ""; }
    virtual void initialize(m3iSystem *system, m3iRoot *root) = 0;
    virtual void render(double dt) = 0;
    virtual void reload() {}
    virtual void touch(m3eInputAction act, uint8_t id, uint16_t x, uint16_t y) {}
    virtual void keyboard(m3eInputAction act, uint8_t key) {}
    virtual void stop() {}
    virtual void close() {}
};

}

melissa::m3iRootApplication *createRootApplication();
